"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("./view");
var sloarToLunar_1 = require("./util/sloarToLunar");
var FullCalendar = /** @class */ (function (_super) {
    __extends(FullCalendar, _super);
    function FullCalendar(el, opts) {
        return _super.call(this, el, opts) || this;
    }
    /**
     * set date
     * @param date
     */
    FullCalendar.prototype.setDate = function (date) {
        var dates = this.parseDate(date);
        this.data = __assign({}, this.data, dates);
    };
    /**
     * next month
     */
    FullCalendar.prototype.nextMonth = function () {
        var _a = this.data, month = _a.month, year = _a.year;
        var nextMonth = month + 1;
        if (nextMonth > 12) {
            this.data.year = year + 1;
            nextMonth = 1;
        }
        this.data = __assign({}, this.data, { month: nextMonth });
        this.onNext(this.data);
        this.trigger('onNext', this.data);
    };
    /**
     * prev month
     */
    FullCalendar.prototype.prevMonth = function () {
        var _a = this.data, month = _a.month, year = _a.year;
        var prevMonth = month - 1;
        if (prevMonth < 1) {
            this.data.year = year - 1;
            prevMonth = 12;
        }
        this.data = __assign({}, this.data, { month: prevMonth });
        this.onPrev(this.data);
        this.trigger('onPrev', this.data);
    };
    /**
     * go back today
     */
    FullCalendar.prototype.goToday = function () {
        this.data = __assign({}, this.data, { year: this.now.getFullYear(), month: this.now.getMonth() + 1, day: this.now.getDate() });
    };
    /**
     * sloar To Lunar
     */
    FullCalendar.sloarToLunar = sloarToLunar_1.sloarToLunar;
    return FullCalendar;
}(view_1.View));
exports.default = FullCalendar;
//# sourceMappingURL=FullCalendar.js.map