"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Emitter = /** @class */ (function () {
    function Emitter() {
    }
    Emitter.mixToClass = function (targetClass) {
        Object.getOwnPropertyNames(Emitter.prototype).forEach(function (name) {
            if (!targetClass.prototype[name]) {
                targetClass.prototype[name] = Emitter.prototype[name];
            }
        });
    };
    Emitter.prototype.bind = function (type, handler) {
        addToHandlers({ handlers: this._handlers || (this._handlers = {}), type: type, handler: handler });
        return this;
    };
    Emitter.prototype.unbind = function (type, handler) {
        if (this._handlers) {
            removeFromHandlers({ handlers: this._handlers, type: type, handler: handler });
        }
        return this;
    };
    Emitter.prototype.trigger = function (type) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (this._handlers) {
            var functions = this._handlers[type];
            if (typeof functions === 'function') {
                functions = [functions];
            }
            if (functions) {
                var i = void 0;
                for (i = 0; i < functions.length; i++) {
                    functions[i].apply(this, args);
                }
            }
        }
        return this;
    };
    Emitter.prototype.hasHandlers = function (type) {
        return this._handlers && this._handlers[type] && this._handlers[type].length;
    };
    return Emitter;
}());
exports.default = Emitter;
function addToHandlers(_a) {
    var handlers = _a.handlers, type = _a.type, handler = _a.handler;
    ;
    (handlers[type] || (handlers[type] = [])).push(handler);
}
function removeFromHandlers(_a) {
    var handlers = _a.handlers, type = _a.type, handler = _a.handler;
    if (handler) {
        if (handlers[type]) {
            handlers[type] = handlers[type].filter(function (func) {
                return func !== handler;
            });
        }
    }
    else {
        delete handlers[type];
    }
}
//# sourceMappingURL=Emitter.js.map